/****************************************************
   Tod Reynolds, Joshua Peng, and Pill Gun Park
   Variable Frequency Electrosense
****************************************************/
//test variables
//ImageButtons button_p;

//***** Global Variables *****************************
import controlP5.*;
ControlP5 controlP5;
int kk = 0;
import processing.serial.*; 
Serial[] myPorts = new Serial[1];
PrintWriter output;
int k = 0;
public int myColorRect = 200;
public int myColorBackground = 100;
float height = 500;
float width = 700;
int index = 0;
PFont myfont;  //initializing our text font

//int u = 0;
boolean newdata = false;
int L = 512;
float[] freq = new float[L];
float[] phase1 = new float[L];
float[] phase2 = new float[L];
float[] fft1 = new float[L];
float[] fft2 = new float[L];
float[] sfft1 = new float[L-5];
float[] sfft2 = new float[L-5];
float[] magbodedata = new float[19];
float[] phasebodedata = new float[19];
float[] freqbodedata = new float[19];
float[] sinmagbodedata = new float[19];
float[] sin1 = new float[L];
float[] sin2 = new float[L];
float bx = width/3;
float by = height/3;
float mag1 = 0;
float mag2 = 0;
float afreq = 0;
float bfreq = 0;
float aphase = 0;
float bphase = 0;
float phasechange = 0;
float magratio = 0;
float mappedphase = 0;
float mappedsinmag = 0;
float mappedmag = 0;
float sinmaglog = 0;
float sinmagratio = 0;
float msin1 = 0;
float msin2 = 0;
float afreqlog = 0;
float bfreqlog = 0;
float magratiolog = 0;
float mappedfreq = 0;
float invmagratiolog = 0;
float sumphase = 0;
float sumsinmag = 0;
float avgphase = 0;
float avgmag = 0;
int a,b;
int buttonheight = 24;
int buttonwidth = 60;
char getdata = 'x';
char calibrate = 'c';
char move = 'm';
char stop = 't';
char fwd = 'f';
char rev = 'r';
char slow = 'l';
char accel = 'a';
char dataacquisition = 'd';


int gww = int(width)-buttonwidth-15;
int gwhp = int(height)-15;
int gwh = gwhp/2;

//***** Main Setup Function *********************************
void setup() {
  output = createWriter("bodeplotdata.txt"); 
  myfont = loadFont("Calibri-Bold-10.vlw");
  textFont(myfont);
  background(30);
  frameRate(60);
  controlP5 = new ControlP5(this);
  InitSerial();
  smooth();  
  
  size(int(width),int(height));
  fill(0);
  noStroke();
  fill(255);
  rect(5,5,gww,gwh);
  rect(5,gwh+10,gww,gwh);
    
  
  strokeWeight(2);
  stroke(0);
  line(50,gwh/2+5,width-15-buttonwidth,gwh/2+5);
  line(50,gwh+gwh/2+10,width-15-buttonwidth,gwh+gwh/2+10);
  line(50,5,50,gwh+5);
  line(50,gwh+10,50,2*gwh+10);

  initiallize();

  controlP5.addButton("Data acquisition",dataacquisition,int(width-buttonwidth-5),int(height-9*buttonheight-15),buttonwidth,buttonheight).setId(10);
  controlP5.addButton("Move",move,int(width-buttonwidth-5),int(height-8*buttonheight-15),buttonwidth,buttonheight).setId(2);
  controlP5.addButton("Stop",stop,int(width-buttonwidth-5),int(height-7*buttonheight-15),buttonwidth,buttonheight).setId(3);
  controlP5.addButton("Forward",fwd,int(width-buttonwidth-5),int(height-6*buttonheight-15),buttonwidth,buttonheight).setId(4);
  controlP5.addButton("Reverse",rev,int(width-buttonwidth-5),int(height-5*buttonheight-15),buttonwidth,buttonheight).setId(5);
  controlP5.addButton("Accel",stop,int(width-buttonwidth-5),int(height-4*buttonheight-15),buttonwidth,buttonheight).setId(6);
  controlP5.addButton("Slow",slow,int(width-buttonwidth-5),int(height-3*buttonheight-15),buttonwidth,buttonheight).setId(7);
  controlP5.addButton("Calibrate",calibrate,int(width-buttonwidth-5),int(height-2*buttonheight-15),buttonwidth,buttonheight).setId(8);
  controlP5.addButton("Get data",getdata,int(width-buttonwidth-5),int(height-buttonheight-5),buttonwidth,buttonheight).setId(9);

}

//***** Main Draw Function *************************************
void draw() {
    if (newdata == true && k < 19) { 
     calc();
     //output.println("afreq: "+afreq+" | bfreq: "+bfreq+" | mag1: "+mag1+" | mag2: "+mag2+ " | aphase: " +aphase+ " | bphase: " +bphase+ " | magratiolog: "+magratiolog+" |phasechange: "+phasechange); 
     output.println("afreq: "+afreq+" | bfreq: "+bfreq+" | mag1: "+mag1+" | mag2: "+mag2+ " | aphase: " +aphase+ " | bphase: " +bphase+ " | magratiolog: "+magratiolog+" |phasechange: "+phasechange+"|sinmaglog: "+sinmaglog); 
     //output.println(" ");
     output.flush();
     //output.close();
    if (k == 0){
     initiallize(); 
    }
    //text("hi",50+5*k,100);
    strokeWeight(5);
    stroke(100);
    //point(mappedfreq,mappedmag);
    point(mappedfreq,mappedphase);
    point(mappedfreq,mappedsinmag);
    magbodedata[k] = mappedmag;
    phasebodedata[k] = mappedphase;
    freqbodedata[k] = mappedfreq;
    sinmagbodedata[k] = mappedsinmag;
    sumphase = sumphase + phasechange;
    sumsinmag = sumsinmag + sinmaglog;
    if (k<18){
    myPorts[0].write(getdata);
    } else {
      avgphase = sumphase/19;
      avgmag = sumsinmag/19;
      sumphase = 0;
      sumsinmag = 0;
      
      if (abs(avgphase)<20){
        text("Object detected:",int(width-buttonwidth-5),50);
        text("Steel Ball",int(width-buttonwidth-5),70);
       }
      
      strokeWeight(2);
      stroke(255,0,0);
      /*
      beginShape(LINES); 
      for (int i = 0; i<18; i++){
      vertex(freqbodedata[i],magbodedata[i]); 
      vertex(freqbodedata[i+1],magbodedata[i+1]);
      }
      endShape();*/
      beginShape(LINES);
      for (int i = 0; i<18; i++){
       vertex(freqbodedata[i],phasebodedata[i]); 
       vertex(freqbodedata[i+1],phasebodedata[i+1]);
      }
      endShape();
      beginShape(LINES);
      for (int i = 0; i<18; i++){
       vertex(freqbodedata[i],sinmagbodedata[i]); 
       vertex(freqbodedata[i+1],sinmagbodedata[i+1]);
      }
      endShape();
    }
    k++;
    newdata = false;
    
    if (k > 18){
      k = 0;
    }
  }
}

public void controlEvent(ControlEvent theEvent) {
  println("got a control event from controller with id "+theEvent.controller().id()+": "+theEvent.controller().value());
  switch(theEvent.controller().id()) {
    case(2):
    println("Move");
    myPorts[0].write(move);
    break;
    case(3):
    println("Stop");
    myPorts[0].write(stop);
    break;
    case(4):
    println("Forward");
    myPorts[0].write(fwd);
    break;
    case(5):
    println("Reverse");
    myPorts[0].write(rev);
    break;
    case(6):
    println("Accel");
    myPorts[0].write(accel);
    break;
    case(7):
    println("Slow");
    myPorts[0].write(slow);
    break;
    case(8):
    println("calibrate");
    myPorts[0].write(calibrate);
    break;
    case(9):
    println("get data");
    k = 0;
    myPorts[0].write(getdata);
    //initiallize();
    break;
    case(10):
    println("Data acquisition");
    myPorts[0].write(dataacquisition); 
    break;
  }
}

//***** Communication with RS232 between processing and the PIC *******************

// initialize the serial port
void InitSerial() {
  // List all the available serial ports
  // you want the one that you plugged in
  println(Serial.list());

  String portList = Serial.list()[1];
  // this assumes the COM port you want is the first one, change the 0 to the place of your comport in the list that appears in the debug window
  myPorts[0] = new Serial(this, portList, 38400);

  // read bytes into a buffer until you get a linefeed (ASCII 10):
  myPorts[0].bufferUntil('\n');
}

// serial event, check which port generated the event, just in case there are more than 1 ports open
void serialEvent(Serial thisPort) { 
  // variable to hold the number of the port:
  int portNumber = -1;

  // iterate over the list of ports opened, and match the 
  // one that generated this event:
  for (int p = 0; p < myPorts.length; p++) {
    if (thisPort == myPorts[p]) {
      portNumber = p;
    }
  }

  // read the serial buffer until a newline appears
  String myString = thisPort.readStringUntil('\n');

  // if you got any bytes other than the newline
  if (myString != null) {
    myString = trim(myString); // ditch the newline

    // split the string at the spaces, save as integers
    float line_received[] = float(split(myString, ' '));
    // grab the data
    if ((line_received.length == 7) && (portNumber==0)){
      freq[index] = line_received[0];
      fft1[index] = line_received[1];
      fft2[index] = line_received[2];
      phase1[index] = line_received[3];
      phase2[index] = line_received[4];  
      sin1[index] = line_received[5];
      sin2[index] = line_received[6];
      //output.println("frequency vector: "+freq[index]+" | fft1: "+fft1[index]+" | fft2: "+fft2[index]+" | phase1: "+sin1[index]+ " | phase2: " +sin2[index]); 
      index++; 
      if (index >= L){
        index = 0;
        newdata = true;
      }
    }
  }
} // end serialEvent


void calc(){
  for (int i=0;i<L-5;i++) {
    sfft1[i] = fft1[i+5];
    sfft2[i] = fft2[i+5];
  }
  mag1 = max(sfft1);
  mag2 = max(sfft2);
  for (int i=5;i<L;i++) {
	if (fft1[i] == mag1) {
		a = i;
	}	
	if (fft2[i] == mag2) {
		b = i;
	}
  }
  afreq = freq[a];
  bfreq = freq[b];
  aphase = phase1[a];
  bphase = phase2[b]-PI;
  
  magratio = mag2/mag1;
  
  phasechange = ((bphase - aphase)/(2*PI))*360;
  if (phasechange > 180){
   phasechange = phasechange - 360; 
  } else if (phasechange < -180){                                                                                  
   phasechange = phasechange+360; 
  }
  
  msin1 = max(sin1)-min(sin1);
  msin2 = max(sin2)-min(sin2);
  sinmagratio = msin2/msin1;
  sinmaglog = 20*log(sinmagratio)/log(10);
   
  afreqlog = log(afreq)/log(10);
  bfreqlog = log(bfreq);  
  magratiolog = 20*log(magratio)/log(10);
  

  
  mappedsinmag = map(sinmaglog,-20,20,gwh+5,5);
  mappedmag = map(magratiolog,-80,80,2*gwh+15,gwh+10);
  mappedphase = map(phasechange,-180,180,gwh+10,height-5);
  mappedfreq = map(afreqlog,2,4,50,625);
}
//frequency vector: 100.0 | fft1: 2176.0 | fft2: 2176.0 | phase1: 2.896614 | phase2: 2.896614
void initiallize(){
   fill(0);
  noStroke();
  fill(255);
  rect(5,5,gww,gwh);
  rect(5,gwh+10,gww,gwh);
    
  
  strokeWeight(2);
  stroke(0);
  line(50,gwh/2+5,width-15-buttonwidth,gwh/2+5);
  line(50,gwh+gwh/2+10,width-15-buttonwidth,gwh+gwh/2+10);
  line(50,5,50,gwh+5);
  line(50,gwh+10,50,2*gwh+10);


  strokeWeight(1);
  stroke(200);
  //line(50,gwh+5-map(20,-20,20,5,gwh+5),width-15-buttonwidth,250-map(80,-80,80,5,245));
  line(50,gwh+5-map(15,-20,20,5,gwh),width-15-buttonwidth,gwh+5-map(15,-20,20,5,gwh));
  line(50,gwh+5-map(10,-20,20,5,gwh),width-15-buttonwidth,gwh+5-map(10,-20,20,5,gwh));
  line(50,gwh+5-map(5,-20,20,5,gwh),width-15-buttonwidth,gwh+5-map(5,-20,20,5,gwh));
  line(50,gwh+5-map(-5,-20,20,5,gwh),width-15-buttonwidth,gwh+5-map(-5,-20,20,5,gwh));
  line(50,gwh+5-map(-10,-20,20,5,gwh),width-15-buttonwidth,gwh+5-map(-10,-20,20,5,gwh));
  line(50,gwh+5-map(-15,-20,20,5,gwh),width-15-buttonwidth,gwh+5-map(-15,-20,20,5,gwh));
 // line(50,gwh+5-map(-20,-20,20,5,245),width-15-buttonwidth,250-map(-80,-80,80,5,245));
 
  line(50,2*gwh+10-map(135,-180,180,5,gwh),width-15-buttonwidth,2*gwh+10-map(135,-180,180,5,gwh));
  line(50,2*gwh+10-map(90,-180,180,5,gwh),width-15-buttonwidth,2*gwh+10-map(90,-180,180,5,gwh));
  line(50,2*gwh+10-map(45,-180,180,5,gwh),width-15-buttonwidth,2*gwh+10-map(45,-180,180,5,gwh));
  line(50,2*gwh+10-map(-45,-180,180,5,gwh),width-15-buttonwidth,2*gwh+10-map(-45,-180,180,5,gwh));
  line(50,2*gwh+10-map(-90,-180,180,5,gwh),width-15-buttonwidth,2*gwh+10-map(-90,-180,180,5,gwh));
  line(50,2*gwh+10-map(-135,-180,180,5,gwh),width-15-buttonwidth,2*gwh+10-map(-135,-180,180,5,gwh));
  /*
  line(50,3*gwh+15-map(135,-180,180,5,gwh),width-15-buttonwidth,3*gwh+15-map(135,-180,180,5,gwh));
  line(50,3*gwh+15-map(90,-180,180,5,gwh),width-15-buttonwidth,3*gwh+15-map(90,-180,180,5,gwh));
  line(50,3*gwh+15-map(45,-180,180,5,gwh),width-15-buttonwidth,3*gwh+15-map(45,-180,180,5,gwh));
  line(50,3*gwh+15-map(-45,-180,180,5,gwh),width-15-buttonwidth,3*gwh+15-map(-45,-180,180,5,gwh));
  line(50,3*gwh+15-map(-90,-180,180,5,gwh),width-15-buttonwidth,3*gwh+15-map(-90,-180,180,5,gwh));
  line(50,3*gwh+15-map(-135,-180,180,5,gwh),width-15-buttonwidth,3*gwh+15-map(-135,-180,180,5,gwh));
*/

  line(map(log(200)/log(10),2,4,50,625),5,map(log(200)/log(10),2,4,50,625),gwh+5);
  line(map(log(300)/log(10),2,4,50,625),5,map(log(300)/log(10),2,4,50,625),gwh+5);
  line(map(log(400)/log(10),2,4,50,625),5,map(log(400)/log(10),2,4,50,625),gwh+5);
  line(map(log(500)/log(10),2,4,50,625),5,map(log(500)/log(10),2,4,50,625),gwh+5);
  line(map(log(600)/log(10),2,4,50,625),5,map(log(600)/log(10),2,4,50,625),gwh+5);
  line(map(log(700)/log(10),2,4,50,625),5,map(log(700)/log(10),2,4,50,625),gwh+5);
  line(map(log(800)/log(10),2,4,50,625),5,map(log(800)/log(10),2,4,50,625),gwh+5);
  line(map(log(900)/log(10),2,4,50,625),5,map(log(900)/log(10),2,4,50,625),gwh+5);
  line(map(log(1000)/log(10),2,4,50,625),5,map(log(1000)/log(10),2,4,50,625),gwh+5);
  line(map(log(2000)/log(10),2,4,50,625),5,map(log(2000)/log(10),2,4,50,625),gwh+5);
  line(map(log(3000)/log(10),2,4,50,625),5,map(log(3000)/log(10),2,4,50,625),gwh+5);
  line(map(log(4000)/log(10),2,4,50,625),5,map(log(4000)/log(10),2,4,50,625),gwh+5);
  line(map(log(5000)/log(10),2,4,50,625),5,map(log(5000)/log(10),2,4,50,625),gwh+5);
  line(map(log(6000)/log(10),2,4,50,625),5,map(log(6000)/log(10),2,4,50,625),gwh+5);
  line(map(log(7000)/log(10),2,4,50,625),5,map(log(7000)/log(10),2,4,50,625),gwh+5);
  line(map(log(8000)/log(10),2,4,50,625),5,map(log(8000)/log(10),2,4,50,625),gwh+5);
  line(map(log(9000)/log(10),2,4,50,625),5,map(log(9000)/log(10),2,4,50,625),gwh+5);
  /*
    line(map(log(200)/log(10),2,4,50,625),gwh+15,map(log(200)/log(10),2,4,50,625),height-5);
  line(map(log(300)/log(10),2,4,50,625),gwh+15,map(log(300)/log(10),2,4,50,625),height-5);
  line(map(log(400)/log(10),2,4,50,625),gwh+15,map(log(400)/log(10),2,4,50,625),height-5);
  line(map(log(500)/log(10),2,4,50,625),gwh+15,map(log(500)/log(10),2,4,50,625),height-5);
  line(map(log(600)/log(10),2,4,50,625),gwh+15,map(log(600)/log(10),2,4,50,625),height-5);
  line(map(log(700)/log(10),2,4,50,625),gwh+15,map(log(700)/log(10),2,4,50,625),height-5);
  line(map(log(800)/log(10),2,4,50,625),gwh+15,map(log(800)/log(10),2,4,50,625),height-5);
  line(map(log(900)/log(10),2,4,50,625),gwh+10,map(log(900)/log(10),2,4,50,625),height-5);
  line(map(log(1000)/log(10),2,4,50,625),gwh+10,map(log(1000)/log(10),2,4,50,625),height-5);
  line(map(log(2000)/log(10),2,4,50,625),gwh+10,map(log(2000)/log(10),2,4,50,625),height-5);
  line(map(log(3000)/log(10),2,4,50,625),gwh+10,map(log(3000)/log(10),2,4,50,625),height-5);
  line(map(log(4000)/log(10),2,4,50,625),gwh+10,map(log(4000)/log(10),2,4,50,625),height-5);
  line(map(log(5000)/log(10),2,4,50,625),gwh+10,map(log(5000)/log(10),2,4,50,625),height-5);
  line(map(log(6000)/log(10),2,4,50,625),gwh+10,map(log(6000)/log(10),2,4,50,625),height-5);
  line(map(log(7000)/log(10),2,4,50,625),gwh+10,map(log(7000)/log(10),2,4,50,625),height-5);
  line(map(log(8000)/log(10),2,4,50,625),gwh+10,map(log(8000)/log(10),2,4,50,625),height-5);
  line(map(log(9000)/log(10),2,4,50,625),gwh+10,map(log(9000)/log(10),2,4,50,625),height-5);
  */
    line(map(log(200)/log(10),2,4,50,625),gwh+10,map(log(200)/log(10),2,4,50,625),2*gwh+10);
  line(map(log(300)/log(10),2,4,50,625),gwh+10,map(log(300)/log(10),2,4,50,625),2*gwh+10);
  line(map(log(400)/log(10),2,4,50,625),gwh+10,map(log(400)/log(10),2,4,50,625),2*gwh+10);
  line(map(log(500)/log(10),2,4,50,625),gwh+10,map(log(500)/log(10),2,4,50,625),2*gwh+10);
  line(map(log(600)/log(10),2,4,50,625),gwh+10,map(log(600)/log(10),2,4,50,625),2*gwh+10);
  line(map(log(700)/log(10),2,4,50,625),gwh+10,map(log(700)/log(10),2,4,50,625),2*gwh+10);
  line(map(log(800)/log(10),2,4,50,625),gwh+10,map(log(800)/log(10),2,4,50,625),2*gwh+10);
  line(map(log(900)/log(10),2,4,50,625),gwh+10,map(log(900)/log(10),2,4,50,625),2*gwh+10);
  line(map(log(1000)/log(10),2,4,50,625),gwh+10,map(log(1000)/log(10),2,4,50,625),2*gwh+10);
  line(map(log(2000)/log(10),2,4,50,625),gwh+10,map(log(2000)/log(10),2,4,50,625),2*gwh+10);
  line(map(log(3000)/log(10),2,4,50,625),gwh+10,map(log(3000)/log(10),2,4,50,625),2*gwh+10);
  line(map(log(4000)/log(10),2,4,50,625),gwh+10,map(log(4000)/log(10),2,4,50,625),2*gwh+10);
  line(map(log(5000)/log(10),2,4,50,625),gwh+10,map(log(5000)/log(10),2,4,50,625),2*gwh+10);
  line(map(log(6000)/log(10),2,4,50,625),gwh+10,map(log(6000)/log(10),2,4,50,625),2*gwh+10);
  line(map(log(7000)/log(10),2,4,50,625),gwh+10,map(log(7000)/log(10),2,4,50,625),2*gwh+10);
  line(map(log(8000)/log(10),2,4,50,625),gwh+10,map(log(8000)/log(10),2,4,50,625),2*gwh+10);
  line(map(log(9000)/log(10),2,4,50,625),gwh+10,map(log(9000)/log(10),2,4,50,625),2*gwh+10); 

fill(255,0,0);
  text(20,40,gwh+5-map(80,-80,80,5,gwh)+3);
  text(15,40,gwh+5-map(60,-80,80,5,gwh)+3);
  text(10,40,gwh+5-map(40,-80,80,5,gwh)+3);
  text(5,45,gwh+5-map(20,-80,80,5,gwh)+1);
  text(0,45,gwh+5-map(0,-80,80,5,gwh)+3);
  text(-5,40,gwh+5-map(-20,-80,80,5,gwh)+3);
  text(-10,35,gwh+5-map(-40,-80,80,5,gwh)+3);
  text(-15,35,gwh+5-map(-60,-80,80,5,gwh)+1);
  text(-20,35,gwh+5-map(-80,-80,80,5,gwh));
  /*
  text(80,40,2*gwh+10-map(80,-80,80,5,gwh)+3);
  text(60,40,2*gwh+10-map(60,-80,80,5,gwh)+3);
  text(40,40,2*gwh+10-map(40,-80,80,5,gwh)+3);
  text(20,40,2*gwh+10-map(20,-80,80,5,gwh)+1);
  text(0,45,2*gwh+10-map(0,-80,80,5,gwh)+3);
  text(-20,35,2*gwh+10-map(-20,-80,80,5,gwh)+3);
  text(-40,35,2*gwh+10-map(-40,-80,80,5,gwh)+3);
  text(-60,35,2*gwh+10-map(-60,-80,80,5,gwh)+1);
  text(-80,35,2*gwh+10-map(-80,-80,80,5,gwh));
  */
  text(180,35,2*gwh+13-map(80,-80,80,5,gwh)+3);
  text(135,35,2*gwh+10-map(60,-80,80,5,gwh)+3);
  text(90,40,2*gwh+10-map(40,-80,80,5,gwh)+3);
  text(45,40,2*gwh+10-map(20,-80,80,5,gwh)+1);
  text(0,45,2*gwh+10-map(0,-80,80,5,gwh)+3);
  text(-45,35,2*gwh+10-map(-20,-80,80,5,gwh)+3);
  text(-90,35,2*gwh+10-map(-40,-80,80,5,gwh)+3);
  text(-135,30,2*gwh+10-map(-60,-80,80,5,gwh)+1);
  text(-180,30,2*gwh+10-map(-80,-80,80,5,gwh));
}
